<?php
/**********************************************************************************
* botAdmin.template.php                                                           *
***********************************************************************************
* SMFBot Project for SMF                                                          *
* =============================================================================== *
* Software Version:           SMFBot 0.1 Integration                              *
*                             ALICE Program E 0.9 Engine                          *
* Software by:                Integration by JRSofty Programming                  *
*                             Engine by: Paul Rydell / Anne Kootstra              *
* Copyright 2007 By:          JRSofty Programming for Integration                 *
*           2001-2007 by:     Program E Development Team                          *
* Support, News at:           http://www.galahtech.org                            *
* Updates at:                 http://smfbot.dev.dansoftaustralia.net              *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the GNU/GPL                                                        *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
**********************************************************************************/
// Just in case I forgot to load the language file we'll do it here again.
loadLanguage('bot');


// had some problems getting the tables to be stretched completely across the screen. So I've added a width setting to get it to do so.

// SYSTEM CONFIG
function template_systemConfig(){
	global $context, $txt, $scripturl;
	if(!isset($_GET['sa']) || $_GET['sa'] != 'modify'){
		// display normally	
		echo "
		<table class='bordercolor' width = '100%'>
			<tr class='titlebg'>
				<td colspan ='2'>{$txt['bot_sys_config']}&nbsp;&nbsp;&nbsp;{<a href='{$scripturl}?action=botsystem&amp;sa=modify'>{$txt['bot_modify']}</a>}</td>
			</tr>
			<tr class='windowbg'>
				<td colspan='2'>{$txt['bot_default_explain']}</td>
			</tr>
			<tr class='titlebg'>
				<td colspan='2'>{$txt['bot_sys_var']}</td>
			</tr>
			<tr class='catbg'>
				<td>{$txt['bot_setting']}</td><td>{$txt['bot_value']}</td>
			</tr>";
		$alternating = 'windowbg';
		foreach($context['defaults']['system'] as $id=>$ctrlArr){
			if($ctrlArr['type'] == 'yesno'){
				echo "
					<tr class='{$alternating}'>
						<td>{$ctrlArr['variable']}</td>
						<td>" . ($ctrlArr['value'] == 1 ? $txt['bot_yes'] : $txt['bot_no']) . "</td>
					</tr>";
			}else{
				echo "
					<tr class='{$alternating}'>
						<td>{$ctrlArr['variable']}</td>
						<td>{$ctrlArr['value']}</td>
					</tr>";	
			}
			$alternating = ($alternating == 'windowbg'? 'windowbg2' : 'windowbg');
		}
		echo "
			<tr class='titlebg'>
				<td colspan='2'>{$txt['bot_bot_def']}</td>
			</tr>
			<tr class='catbg'>
				<td>{$txt['bot_setting']}</td><td>{$txt['bot_value']}</td>
			</tr>";
		$alternating = 'windowbg';
		foreach($context['defaults']['bot'] as $id=>$ctrlArr){
			echo "
			<tr class='{$alternating}'>
				<td>{$ctrlArr['variable']}</td>
				<td>{$ctrlArr['value']}</td>
			</tr>";
			$alternating = ($alternating == 'windowbg'? 'windowbg2' : 'windowbg');
		}
		echo "
		</table>";
	}else{
		// display as form
		echo "
			<form action='{$scripturl}?action=botsystem&sa=saveconfig' method='POST'>
			<table class='bordercolor' width = '100%'>
			<tr class='titlebg'>
				<td colspan ='2'>{$txt['bot_sys_config']}</td>
			</tr>
			<tr class='windowbg'>
				<td colspan='2'>{$txt['bot_default_explain']}</td>
			</tr>
			<tr class='titlebg'>
				<td colspan='2'>{$txt['bot_sys_var']}</td>
			</tr>
			<tr class='catbg'>
				<td>{$txt['bot_setting']}</td><td>{$txt['bot_value']}</td>
			</tr>";
		$alternating = 'windowbg';
		foreach($context['defaults']['system'] as $id=>$ctrlArr){
			if($ctrlArr['type'] == 'yesno'){
				echo "
					<tr class='{$alternating}'>
						<td>{$ctrlArr['variable']}</td>
						<td><select name='{$ctrlArr['variable']}'>";
				if($ctrlArr['value'] == '1'){
					echo "<option value='1' selected>{$txt['bot_yes']}</option>";
				}else{
					echo "<option value='1'>{$txt['bot_yes']}</option>";
				}
				if($ctrlArr['value'] == '0'){
					echo "<option value='0' selected>{$txt['bot_no']}</option>";	
				}else{
					echo "<option value='0'>{$txt['bot_no']}</option>";
				}
				echo "
						</select></td>
					</tr>";
			}else{
				echo "
					<tr class='{$alternating}'>
						<td>{$ctrlArr['variable']}</td>
						<td><textarea name='{$ctrlArr['variable']}'>{$ctrlArr['value']}</textarea></td>
					</tr>";	
			}
			$alternating = ($alternating == 'windowbg'? 'windowbg2' : 'windowbg');
		}
		echo "
			<tr class='titlebg'>
				<td colspan='2'>{$txt['bot_bot_def']}</td>
			</tr>
			<tr class='catbg'>
				<td>{$txt['bot_setting']}</td><td>{$txt['bot_value']}</td>
			</tr>";
		$alternating = 'windowbg';
		foreach($context['defaults']['bot'] as $id=>$ctrlArr){
			echo "
			<tr class='{$alternating}'>
				<td>{$ctrlArr['variable']}</td>
				<td><textarea name='{$ctrlArr['variable']}'>{$ctrlArr['value']}</textarea></td>
			</tr>";
			$alternating = ($alternating == 'windowbg'? 'windowbg2' : 'windowbg');
		}
		echo "
			<tr class='catbg'>
				<td colspan='2'><input type='submit' value='Store' /></td>
			</tr>
		</table></form>";
	}
}


// SYSTEM MESSAGES AND CONFIRM MESSAGES
function template_sysmsg(){
	global $context, $txt, $scripturl;
	if(!isset($context['bot_verify']) || !$context['bot_verify']){
		echo 
		"<table class='bordercolor' width='100%'>
			<tr class='titlebg'>
				<td>System Message</td>
			</tr>
			<tr class='windowbg'>
				<td>{$context['bot_msg']}</td>
			</tr>
		</table>";
	}else{
		echo "
		<form method='POST' action='{$scripturl}?action=botman&sa={$context['bot_sa']}&do=1'>";
		
		foreach($context['hidden'] as $name=>$value){
			echo "<input type='hidden' name='bot{$name}' value='{$value}' />\n";	
		}
			
		echo "
		<table class='bordercolor' width='100%'>
			<tr class='titlebg'>
				<td>Verify</td>
			</tr>
			<tr class='windowbg'>
				<td>{$context['bot_msg']}</td>
			</tr>
			<tr class='catbg'>
				<td><a href='{$scripturl}index.php?action=botman&amp;sa=list'>Cancel</a>&nbsp;&nbsp;<input type='submit' value='OK' /></td>
			</tr>
		</table>
		</form>
		";
	}
}

// AUTO STEP FOR DELETION OF BOT ***
function template_botDelStep(){
	global $context, $txt, $scripturl;
	echo "
	<form method='POST' action='{$scripturl}?action=botman&sa=delete&do={$context['nextstep']}' name='botdelstep'>";
	foreach($context['hidden'] as $name=>$value){
		echo "<input type='hidden' name='{$name}' value='{$value}' />";
	}
	echo "
		<table class='bordercolor' width ='100%'>
			<tr class='windowbg'>
				<td>{$txt['bot_sorry_pause']}</td>
			</tr>
			<tr class='windowbg2'>
				<td>{$context['bot_msg']}</td>
			</tr>
			<tr class='catbg'>
				<td><input type='submit' value='Continue' /></td>
			</tr>
		</table>
	</form>
	<script type='text/javascript'>
		setTimeout('document.botdelstep.submit()',5000);
	</script>
	";	
}

// AUTO STEP FOR TEACHING OF BOT ****
function template_botTeachStep(){
	global $context, $txt, $scripturl;
	echo "<form method='POST' action='{$scripturl}?action=botman&sa=teach&do={$context['nextstep']}&botid={$context['botid']}' name='botteachstep'>\n";
	foreach($context['hidden'] as $id=>$value){
		echo "<input type='hidden' name='hid{$id}' value='{$value}' />\n";	
	}
	echo "
	<table class='bordercolor' width='100%'>
		<tr class='titlebg'>
			<td>{$txt['bot_loading_aiml']}</td>
		</tr>
		<tr class='windowbg'>
			<td><b>{$txt['bot_sorry_pause']}</b></td>
		</tr>
		<tr class='windowbg2'>
			<td>{$context['bot_msg']}</td>
		</tr>
		<tr class='catbg'>
			<td><input type='submit' value='Continue' /></td>
		</tr>
	</table>
	</form>
	<script type='text/javascript'>
		setTimeout('document.botteachstep.submit()', 5000);
	</script>
	";
	
}

// DELETE MIND STEPING
function template_botEraseStep(){
	global $context, $txt, $scripturl;
	echo"<form method='POST' action='{$scripturl}?action=botman&sa=empty&do={$context['do']}&botid={$context['botid']}' name='boterasestep'>\n
		<table class='bordercolor' width='100%'>
			<tr class='titlebg'>
				<td>{$txt['bot_mind_erase']}</td>
			</tr>
			<tr class='windowbg'>
				<td><b>{$txt['bot_sorry_pause']}</b></td>
			</tr>
			<tr class='windowbg2'>
				<td>&nbsp;{$context['bot_msg']}</td>
			</tr>
			<tr class='catbg'>
				<td><input type='submit' value='Continue' /></td>
			</tr>
		</table>
	</form>
	<script type='text/javascript'>
		setTimeout('document.boterasestep.submit()', 5000);
	</script>
	";
					
}

// SHOW FILES FOR TEACHING OF BOT
function template_showfiles(){
	global $context, $txt, $scripturl;
	echo "
		<form method='POST' action='{$scripturl}?action=botman&sa=teach&do=1&botid={$context['botid']}' name='botshowfiles'>";
	if(count($context['files']) == 0){
		// NO FILES ARE AVAILABLE
		echo"<table class='bordercolor' width='100%'>
				<tr class='titlebg'>
					<td><b>{$txt['bot_files_header']}</b></td>
				</tr><tr class='windowbg'>
					<td>{$txt['bot_no_files']}</td>
				</tr>
			</table></form>";
	}else{
		// LIST FILES AVAILABLE
		echo "<table class='bordercolor' width='100%'>
				<tr class='titlebg'>
					<td colspan='10'><b>{$txt['bot_files_header']}</b></td>
				</tr><tr class='windowbg'>";
				$rCnt = 0;
		foreach($context['files'] as $id=>$value){
			echo "
				<td>
					<input type='checkbox' name='files[]' value='{$value}' class='check' />
				</td>
				<td>
					{$value}
				</td>";
			$rCnt++;
			if($rCnt == 4){
				echo "
					</tr>
					<tr class='windowbg'>";
				$rCnt = 0;
			}
		}
		// FILL OUT ANY EMPTY CELLS
		if($rCnt < 4 && $rCnt > 0){
			for($i = $rCnt; $i <= 3; $i++){
				echo "
					<td>
						&nbsp;
					</td>
					<td>
						&nbsp;
					</td>";
			}
        }
		echo "</tr><tr class='catbg'>
				<td colspan='8'>Select All <input type=\"checkbox\" onClick=\"invertAll(this,this.form,'files[]')\" class=\"check\" /><input type='submit' value='Teach' /></td>
			</tr>
		</table></form>";
	}
}
function template_newbot(){
	global $context, $scripturl, $txt, $settings, $modsettings;
	// if we are editing the bot then the form must go to a different url.
	if(!$context['editbot']){
		echo "<form action='{$scripturl}?action=botman&sa=create&do=1' method='POST' name='botcreate'>
		<table class='bordercolor' width='100%'>
			<tr class='titlebg'>
				<td colspan='2'>{$txt['bot_create']}</td>
			</tr>
			<tr class='catbg'>
				<td><b>{$txt['bot_setting']}</b></td><td><b>{$txt['bot_value']}</b></td>
			</tr>";
	}else{
		echo "<form action='{$scripturl}?action=botman&sa=modify&botid={$context['botid']}&do=1' method='POST' name='botmodify'>
		<table class='bordercolor' width='100%'>
			<tr class='titlebg'>
				<td colspan='2'>{$txt['bot_edit']}</td>
			</tr>
			<tr class='catbg'>
				<td><b>{$txt['bot_setting']}</b></td><td><b>{$txt['bot_value']}</b></td>
			</tr>
			<tr class='windowbg'>
				<td><b>Bot ID</b></td><td>{$context['botid']}</td>
			</tr>
			<tr class='windowbg2'>
				<td><b>Bot Name</b></td><td>{$context['botname']}</td>
			</tr>
			<tr class='windowbg'>
				<td><b>Bot User</b></td><td>{$context['botuser']}</td>
			</tr>";
	}
	// here we list all the bot's personality parameters
	$alternate = 'windowbg';
	foreach($context['bot'] as $name=>$value){
		echo "<tr class='{$alternate}'>
				<td><b>{$name}</b></td><td><textarea name='{$name}'>{$value}</textarea></td>
			  </tr>";
		$alternate = ($alternate == 'windowbg' ? 'windowbg2' : 'windowbg');
	}
	echo "
			<tr class='{$alternate}'>
				<td><b>Board</b></td><td><select name='bot_board'>";
	if(!$context['editbot']){
		foreach($context['boards'] as $brdid=>$brdname){
			echo "<option value='{$brdid}'>{$brdname}</option>";
		}
	}else{
		foreach($context['boards'] as $brdid=>$brdname){
			if($brdid == $context['selectedboard']){
				echo "<option value='{$brdid}' selected>{$brdname}</option>";
			}else{
				echo "<option value='{$brdid}'>{$brdname}</option>";		
			}	
		}	
	}
	echo "
				</select></td>
			</tr>";
	echo "
			<tr class='catbg'>
				<td colspan='2'><input type='submit' value='Store' /></td>
			</tr>
		</table>
	</form>";
		
}

function template_listbots(){
	global $context, $scripturl, $sourcedir, $txt, $settings;
	echo "
			<form name='delform' action='{$scripturl}?action=botman&sa=delete' method='POST'>
				<table class='bordercolor' width='100%'>
					<tr class='titlebg'>
						<td colspan='7'>{$txt['bot_list']}&nbsp;{<a href='{$scripturl}?action=botman&amp;sa=create' title='Create New Bot'>{$txt['bot_create']}</a>}</td>
					</tr>
					<tr class='windowbg'>
						<td class='smalltext' colspan='7'>{$txt['bot_list_explain']}</td>
					</tr>
					<tr class='catbg'>
						<td><input type=\"checkbox\" onClick=\"invertAll(this, this.form, 'bot[]')\" class=\"check\" /></td>
						<td>{$txt['bot_col_name']}</td>
						<td>{$txt['bot_col_user']}</td>
						<td>{$txt['bot_col_enabled']}</td>
						<td>{$txt['bot_col_loaded']}</td>
						<td>{$txt['bot_col_boards']}</td>
						<td>Special</td>
					</tr>";
					if(count($context['bots']) == 0){
						echo"
					<tr>
						<td colspan='7' class='windowbg2'>{$txt['no_bots']}&nbsp;<a href='{$scripturl}?action=botman&amp;sa=create' title='Create New Bot'>{$txt['bot_create']}</a></td>
					</tr>";
					}else{
						$alternate = 'windowbg';
						foreach($context['bots'] as $id => $botdata){
							echo "
					<tr class='{$alternate}'>
						<td>&nbsp;&nbsp;<input type='checkbox' name='bot[]' value='{$id}' class='check' /></td>
						<td><a href='{$scripturl}?action=botman&amp;sa=modify&amp;botid={$id}' title='Modify Bot'>{$botdata['botname']}</a></td>
						<td><a href='{$scripturl}?action=profile&amp;u={$botdata['botuser_id']}' title='Modify Profile'>{$botdata['botuser']}</a></td>
						<td><a href='{$scripturl}?action=botman&amp;sa=enable&amp;botid={$id}' title='Enable/Disable Bot'>" .($botdata['enabled'] == 1 ? "<img src='{$settings['images_url']}/bot_enabled.png' alt='{$txt['bot_enabled']}'>" : "<img src='{$settings['images_url']}/bot_disabled.png' alt='{$txt['bot_disabled']}'>") . "</a></td>
						<td><a href='{$scripturl}?action=botman&amp;sa=teach&amp;botid={$id}' title='Teach Bot'>" .($botdata['loaded'] == 1? "<img src='{$settings['images_url']}/bot_enabled.png' alt='{$txt['bot_loaded']}'>" : "<img src='{$settings['images_url']}/bot_disabled.png' alt='{$txt['bot_unloaded']}'>") . "</a></td>
						<td>{$botdata['boardname']}</td>
						<td>" . ($botdata['loaded'] == 1 ? "<a href='{$scripturl}?action=botman&amp;sa=empty&amp;botid={$id}' title='Erase Bot Mind'>{$txt['bot_mind_erase']}</a>" : "&nbsp;") . "</td>
					</tr>";
							$alternate = ($alternate == 'windowbg' ? 'windowbg2' : 'windowbg');
						}
					}
echo"				<tr class='catbg'>
						<td colspan='7'><input type='submit' value='Delete' /></td>
					</tr>
				</table></form>";
				
}

?>