<?php
/**********************************************************************************
* botadmin.php                                                                    *
***********************************************************************************
* SMFBot Project for SMF                                                          *
* =============================================================================== *
* Software Version:           SMFBot 0.1 Integration                              *
*                             ALICE Program E 0.9 Engine                          *
* Software by:                Integration by JRSofty Programming                  *
*                             Engine by: Paul Rydell / Anne Kootstra              *
* Copyright 2007 By:          JRSofty Programming for Integration                 *
*           2001-2007 by:     Program E Development Team                          *
* Support, News at:           http://www.galahtech.org                            *
*                             and                                                 *
*                             http://jrsofty1.stinkbugonline.com                  *
* Updates at:                 http://smfbot.dev.dansoftaustralia.net              *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the GNU/GPL                                                        *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
**********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');
	// load the language file so we can access it.
	loadLanguage('bot');
	// Define the maximum number of bots allowed. This is to prevent someone from over loading their database.
	define("MAX_BOT", 4);
	/*
		function BotSystem is used to gather the bot settings for editing by the administrator
		the it will use the systemConfig sub-template of the botAdmin.template.php file
	*/
	function BotSystem(){
		global $context, $modSettings, $db_prefix;
		// configuring the mod settings
		adminIndex('bot_system');
		$context['page_title'] = 'Bot System Configuration';
		// All bot default bot settings are prefixed with bot. Hopefully this won't cause problems with other mods.
		if(isset($_REQUEST['sa'])){
			if($_REQUEST['sa'] == 'saveconfig'){
				foreach($_POST as $name=>$value){
					if(substr($name,0,3) == 'bot'){
						$qry = "UPDATE {$db_prefix}settings SET value = '{$value}' WHERE variable = '{$variable}'";
						db_query($qry,__FILE__,__LINE__);	
					}	
				}	
			}	
		}
		$qry = "SELECT variable, value FROM {$db_prefix}settings WHERE variable LIKE 'bot%'";
		$qid = db_query($qry,__FILE__,__LINE__);
		
			/* 
				now we load them all to the context variable to send off to the template system
				NOTE: Yes I know I should be able to do this by using the variable $modSettings.
				This may be changed before release depending on the amount of time it takes. Either way I'll need
				to iterate through the the information because I need ONLY the information that starts with 'bot' and not
				all the other settings found in $modSettings.
			*/
		$context['defaults']['system'] = array();
		$context['defaults']['bot'] = array();
		while(list($variable, $value) = mysql_fetch_array($qid, MYSQL_BOTH)){
			if(substr($variable,0,6) !== 'botDEF'){
				// this is for actual system stuff
				if($value == '1' || $value == '0' ){
					// Yes or No answers only
					$context['defaults']['system'][] = array( 'variable' => $variable, 'value' =>$value, 'type' => 'yesno');
				}else{
					// normal text answers
					$context['defaults']['system'][] = array( 'variable' => $variable, 'value' =>$value, 'type' => 'text');
				}
			}else{
				// bots do not have only yes or no default settings only text values
				$context['defaults']['bot'][] = array ('variable' => $variable, 'value'=>$value, 'type' => 'text');
			}
		}
		mysql_free_result($qid);
		$context['sub_template'] = 'systemConfig';
		loadTemplate('botAdmin');
		
	}
	/*
		function BotManage handles most of the other bot requirements. It will decide according to the subaction array
		which function should be fired. These functions operate as both display and storage functions. These are the main
		administrative functions for the bot system.
	*/
	function BotManage(){
		global $context, $modSettings, $txt, $db_prefix;
		adminIndex('bot_manage');
		/* 
			build the subaction array subaction => function 
			I actually thought about commenting what each line of the array does
			but if you can't figure that out on your own then you really 
			shouldn't be messing with my code.
		*/
		$subarr = array(	
							'list'		=>	'BotList', 
							'create'	=>	'CreateBot',
							'modify'	=>	'EditBot',
							'delete'	=>	'DeleteBotSMF',
							'teach'		=>	'TeachBot',
							'enable'	=>	'EnableBot',
							'empty'		=>	'EmptyMind',
							
						);
		// check to ensure sa has been set. If not then we set it.
		if(!isset($_REQUEST['sa'])){
			$subact = 'list';	
		}else{
			$subact = $_REQUEST['sa'];
		}
		// launch the sub action function
		$subarr[$subact]();
	}
	
	function BotList(){
		global $context, $db_prefix, $txt;
		$context['sub_template'] = 'listbots';
		$context['page_title'] = 'List Bots';
		$context['bots'] = array();
		/*
			Here we are gathering the bots that are created along with their important data from other tables.
			This is particularly important because it looks like crap if you give just a ID_MEMBER and not the actual
			Username.
			
			In later versions I want to change how boards are handled. This is why we will give only a board ID for now.
			Eventual plan is that all bots can talk on all boards.
		*/
		$qry = "
			SELECT b.id as id, b.botname as botname, b.ID_MEMBER as botid, m.ID_MEMBER as memid, m.memberName as botuser, b.enabled as enabled, b.botloaded as loaded, b.boards as boards, o.name as boardname
			FROM {$db_prefix}bots as b
			LEFT JOIN {$db_prefix}members as m
			ON m.ID_MEMBER = b.ID_MEMBER
			LEFT JOIN {$db_prefix}boards as o 
			ON o.ID_BOARD = b.boards
			";
		$qid = db_query($qry, __FILE__,__LINE__);
		// put all the responses to context for the template
		while($row = mysql_fetch_array($qid, MYSQL_BOTH)){
			$context['bots'][$row['id']]['botname'] = $row['botname'];
			$context['bots'][$row['id']]['botuser'] = $row['botuser'];
			$context['bots'][$row['id']]['botuser_id'] = $row['botid'];
			$context['bots'][$row['id']]['enabled'] = $row['enabled'];
			$context['bots'][$row['id']]['loaded'] = $row['loaded'];
			$context['bots'][$row['id']]['boards'] = $row['boards'];
			$context['bots'][$row['id']]['boardname'] = $row['boardname']; 	
		}
		mysql_free_result($qid);
		loadTemplate('botAdmin');
	}
	function CreateBot(){
		global $modSettings, $context, $txt, $db_prefix;
		$context['page_title'] = 'Create Bot';
		if(!isset($_REQUEST['do']) || $_REQUEST['do'] = 0){
			/*
				first thing we do is check how many bots are already created if there are more than 
				the allowed limit then we show only a message saying that they cannot add any new bots
			*/
			$qry = "SELECT COUNT(*) FROM {$db_prefix}bots";
			$qid = db_query($qry,__FILE__,__LINE__);
			list($botcount) = mysql_fetch_array($qid,MYSQL_BOTH);
			mysql_free_result($qid);
			if($botcount < MAX_BOT){
				$context['sub_template'] = 'newbot';
				// since we use the same sub_template for editing we need to say if we are creating or editing.
				$context['editbot'] = false;
				$context['bot'] = array();
				/* 
					All bot settings start with bot. However, if they are bot_ they are used as defaults for new bots.
					Again I'm sure that I can get these from $modSettings but then I would still have to iterate through
					all the stuff I don't need. Eventually this might change depending on speed issues.
				*/
				$qry = "SELECT variable, value FROM {$db_prefix}settings WHERE variable LIKE 'botDEF%'";
				$qid = db_query($qry,__FILE__,__LINE__);
				$context['bot']['bot_name'] = '';
				while(list($varname,$value) = mysql_fetch_array($qid,MYSQL_BOTH)){
					// we only want the bot default settings which are prefixed with bot_ not the systemsettings prefixed with bot only.
					
					$ivarname = str_replace('botDEF','',$varname);
					$context['bot'][$ivarname] = $value;	
					
				}
				mysql_free_result($qid);
				$qry = "SELECT ID_BOARD, name FROM {$db_prefix}boards";
				$qid = db_query($qry,__FILE__,__LINE__);
				while(list($boardid, $boardname) = mysql_fetch_array($qid,MYSQL_BOTH)){
					$context['boards'][$boardid]=$boardname;	
				}
				mysql_free_result($qid);
			}else{
				$context['sub_template'] = 'sysmsg';
				$context['bot_msg'] = $txt['bot_too_many_bots'];
			}
		}else{
			
			// create a new user for the bot?
			if($modSettings['botAutoUserCreate']){
				$pword = '';
				/*
					We need to provide a password for our bot's user. This is to prevent someone from hacking into the bot's
					account and using it to gain access to the board. So what we are going to do is generate a random password
					and assign it to the user account.
				*/
				$charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				// The $charset is the character string from which the password will be generated from
				srand((double)microtime()*1000000);
				for($i = 0;$i < $modSettings['botPasswordLength'];$i++){
					$pword .= substr($charset, rand() % strlen($charset) , 1);	
				}
				// let's build that regOptions array.
				$regOptions = array(
									'interface' => 'admin',
									'username' => $_POST['bot_name'],
									'email' => $_POST['bot_name'].$modSettings['botEmail'],
									'password' => $pword,
									'password_check' => $pword,
									'check_reserved_name' => false,
									'check_password_strength' => false,
									'check_email_ban' => false,
									'send_welcome_email' => false,
									'require' => 'nothing',
									'extra_register_vars' => array(),
									'theme_vars' => array(),
								);
				require_once('Subs-Members.php');
				// register the user (it should do this silently according to SMF Documentation.
				$botuserid = registerMember($regOptions);
			}else{
				// if we don't create a user we will just set the number as 0 meaning guest. 
				$botuserid = 0;
			}
			// now to build the rest of the bot information.
			$qry = "INSERT INTO {$db_prefix}bots (botname, ID_MEMBER,enabled,botloaded,boards) VALUES ('{$_POST['bot_name']}',{$botuserid},0,0,'{$_POST['bot_board']}')";
			db_query($qry,__FILE__,__LINE__);
			/* 
				we need to know what the bot's botid as given from the bots table is so we request it here.
				NOTE: This ONLY works because we are not using a BIGINT type in the id column of the bots table.
			*/
			$botid = mysql_insert_id();
			// now we need to load the bot's system variables. This isn't the mind but more like the personality
			foreach($_POST as $name=>$value){
				if($name != 'bot_board'){
					$name = (substr($name, 0,4) == 'bot_' ? str_replace('bot_','', $name) : $name);
					$qry = "INSERT INTO {$db_prefix}bot (bot,name,value) VALUES ({$botid},'{$name}','{$value}')";
					db_query($qry,__FILE__,__LINE__);	
				}
			}
			// Output the status of the bot.
			$context['sub_template'] = 'sysmsg';
			$context['bot_msg'] = ($botuserid > 0 ? $txt['bot_user_create_complete'] . ' ' : '') . $txt['bot_created_complete'];
		}
		loadTemplate('botAdmin');
	}
	
	function EditBot(){
		global $context, $txt, $db_prefix;
		// we need to make sure that there is a bot id else nothing happens!
		$context['page_title'] = 'Modify Bot';
		if(!isset($_GET['botid'])){
			$context['sub_template'] = 'sysmsg';
			$context['bot_msg'] = $txt['bot_no_id'];	
		}else{
			if(!isset($_REQUEST['do']) || $_REQUEST['do'] == 0){			
				// setup for display of bot's current settings for editing.
				$context['sub_template'] = 'newbot';
				$context['bot'] = array();
				$context['botid'] = $_GET['botid'];
				$qry = "SELECT b.id as botid, b.ID_MEMBER as botuser, b.botname as botname, b.boards as boards, p.name as variable, p.value as value
				FROM {$db_prefix}bots as b
				LEFT JOIN {$db_prefix}bot as p
				ON b.id = p.bot
				WHERE b.id = {$_GET['botid']}";
				$qid = db_query($qry, __FILE__,__LINE__);
				while(list($botid,$botuser,$botname,$boards,$varname,$value) = mysql_fetch_array($qid,MYSQL_BOTH)){
					/*
						We need to convert the bot table's names to names that match form controls in the template
						so we need to add 'bot_' to the beginning of each name.
					*/
					if($varname != 'name'){
						$context['bot'][$varname] = $value;	
					}
					$context['botname'] = $botname;
					$context['selectedboard'] = $boards;
					$context['botid'] = $botid;
					$context['botuser'] = $botuser;
				}
				mysql_free_result($qid);
				$qry = "SELECT ID_BOARD, name FROM {$db_prefix}boards";
				$qid = db_query($qry,__FILE__,__LINE__);
				while(list($boardid, $boardname) = mysql_fetch_array($qid,MYSQL_BOTH)){
					$context['boards'][$boardid]=$boardname;	
				}
				mysql_free_result($qid);
				// yep we need to tell it we are editing so that it sends the correct requests.
				$context['editbot'] = true;
			}else{
				// if $_REQUEST['do'] is anything but 0 then we need to do the saving into database.
				foreach($_POST as $name=>$value){
					if($name != 'bot_board'){
						$qry = "UPDATE {$db_prefix}bot SET value = '{$value}' WHERE bot = {$_GET['botid']} AND name = '{$name}'";
						db_query($qry,__FILE__,__LINE__);	
					}
				}
				$qry = "UPDATE {$db_prefix}bots SET boards = '{$_POST['bot_board']}' WHERE id = {$_GET['botid']}";
				db_query($qry,__FILE__,__LINE__);
				$context['sub_template'] = 'sysmsg';
				$context['bot_msg'] = $txt['bot_edited'];	
			}
		}			
		loadTemplate('botAdmin');
	}
	
	// had to change the naming convention for this function because it copies something from Program E :(
	function DeleteBotSMF(){
		global $context, $txt, $db_prefix, $modSettings;		
		$context['page_title'] = 'Delete Bot';
		if(!isset($_REQUEST['do']) || $_REQUEST['do'] == 0){
			$context['sub_template'] = 'sysmsg';
			$context['bot_verify'] = true;
			$context['bot_sa'] = 'delete';
			$context['bot_msg'] = $txt['bot_do_you_wish']. '<br />';
			foreach($_POST as $name=>$botid){
				$context['hidden'][$name] = $botid;
				$context['bot_msg'] .= $name . '<br />';	
			}
		}else{
			$context['sub_template'] = 'botDelStep';
			// notice we do not remove the bot's posts. 
			if($_REQUEST['do'] == 1){
				$context['nextstep'] = 2;
				$context['bot_msg'] = $txt['bot_mind_deleted'];
				// Step 1 removes bot's mind
				foreach($_POST['bot'] as $name=>$value){
					$context['hidden'][$name] = $value;										
					$qry = "DELETE FROM {$db_prefix}patterns WHERE bot = {$value}";
					db_query($qry,__FILE__,__LINE__);
					$qry = "DELETE FROM {$db_prefix}templates WHERE bot = {$value}";
					db_query($qry,__FILE__,__LINE__);
				}
			}elseif($_REQUEST['do'] == 2){
				$context['nextstep'] = 3;
				$context['bot_msg'] = $txt['bot_personality_deleted'];
				// Step 2 removes the bot's personality
				foreach($_POST as $name=>$value){
					$context['hidden'][$name]=$value;
					$qry = "DELETE FROM {$db_prefix}bot WHERE bot = {$value}";
					db_query($qry,__FILE__,__LINE__);
					$qry = "DELETE FROM {$db_prefix}convlog WHERE bot = {$value}";
				}	
			}elseif($_REQUEST['do'] == 3){
				$context['nextstep'] = 4;
				$context['bot_msg'] = $txt['bot_user_removed'];
				// Step 3 removes the bot's actual forum membership if botAutoUserCreate is active.
				if($modSettings['botAutoUserCreate']){
					require_once('Subs-Members.php');				
					foreach($_POST as $name=>$value){
						$context['hidden'][$name]=$value;
						$qry = "SELECT ID_MEMBER FROM {$db_prefix}bots WHERE id = {$value}";
						$qid = db_query($qry,__FILE__,__LINE__);
						list($delID) = mysql_fetch_array($qid,MYSQL_BOTH);
						mysql_free_result($qid);
						// I know deleteing them one at a time might seem slow I'll probably change this later.
						if($delID > 0 ){
							deleteMembers($delID);
						}	
					}
				}
				
			}elseif($_REQUEST['do'] == 4){
				$context['nextstep'] = 5;
				$context['bot_msg'] = $txt['bot_removed'];
				// Step 4 removes the rest of the bot stuff.	
				foreach($_POST as $name=>$value){
					$qry = "DELETE FROM {$db_prefix}gmcache WHERE bot = {$value}";
					db_query($qry, __FILE__,__LINE__);
					$qry = "DELETE FROM {$db_prefix}gossip WHERE bot = {$value}";
					db_query($qry,__FILE__,__LINE__);
					$qry = "DELETE FROM {$db_prefix}bots WHERE id = {$value}";
					db_query($qry, __FILE__,__LINE__);	
				}
			}else{
				$context['sub_template'] = 'sysmsg';
				$context['bot_msg'] = ($_REQUEST['do'] == 'Cancel' ? $txt['bot_delete_canceled'] : $txt['bot_delete_complete']);	
			}
		}	
				
		loadTemplate('botAdmin');
	}
	
	function TeachBot(){
		global $context, $db_prefix, $modSettings, $sourcedir, $txt;
		$context['page_title'] = 'Teach Bot';
		if(!isset($_GET['botid'])){
			$context['sub_template'] = 'sysmsg';
			$context['bot_msg'] = $txt['bot_no_id'];	
		}else{
			$context['botid'] = $_GET['botid'];
		 	if(!isset($_REQUEST['do']) || $_REQUEST['do'] == 0){
			 	// here we need to gather all the AIML files to display them.
			 	$context['sub_template'] = 'showfiles';
			 	$aimlpath = $sourcedir . '/bot/aiml';
			 	$qry = "SELECT files FROM {$db_prefix}bots WHERE id = {$_GET['botid']}";
			 	$qid = db_query($qry,__FILE__,__LINE__);
			 	list($fils) = mysql_fetch_array($qid,MYSQL_BOTH);
			 	mysql_free_result($qid);
			 	$filArr = split(' ',$fils);
			 	$dh = opendir($aimlpath);
			 	while(($file = readdir($dh)) !== false){
				 	// We only want AIML files
				 	if(strtolower(substr($file,-5)) == '.aiml'){
					 	// We only want to display files that are not already loaded
					 	if(!in_array($file,$filArr)){
							$context['files'][] = $file;	
						}
					}
			 	}
			 	closedir($dh);
		 	}else{
			 	$context['sub_template'] = 'botTeachStep';
				require_once('bot/src/admin/botloaderfuncs.php');
				if($_REQUEST['do'] == 1){
					
					/*  
					    DO 1 gathers from the original form.
					    DO 2 gathers from the auto form
					    DO 3 indicates that the everything is completed.
					    
						Take the files and put them into the context array for 
						being sent back to the template system. This way we aren't useing
						$_SESSION to pass this information only via POST.
						We then take the very first file from the context list and 
						Send it to the learn() function. Also adding it to the list of installed files.
						On the next refresh we do the same thing over and over again until there are no more files. 
						Then we set the DO = 3 and exit.
					*/
					foreach($_POST['files'] as $name=>$value){
						$fileArr[] = $value;	
					}
					rsort($fileArr);
					$learnfile = array_pop($fileArr);
					learn($learnfile);
					$context['bot_msg'] = $learnfile . $txt['bot_aiml_loaded'];
					// add the file to the bot's list of files loaded
					$qry = "UPDATE {$db_prefix}bots SET files = CONCAT(files,'{$learnfile} ') WHERE id = {$_GET['botid']}";
					db_query($qry);
					if(count($fileArr) > 0){
						$context['hidden'] = $fileArr;
						$context['nextstep'] = 2;		
					}else{
						$context['nextstep'] = 3;
					}
					
				}elseif($_REQUEST['do'] == 2){
					$fileArr = array();
					foreach($_POST as $name=>$value){
						if(substr($name,0,3) == 'hid'){
							$fileArr[] = $value;
						}
					}
					$learnfile = array_pop($fileArr);
					learn($learnfile);
					$context['bot_msg'] = $learnfile . $txt['bot_aiml_loaded'];
					$qry = "UPDATE {$db_prefix}bots SET files = CONCAT(files, '{$learnfile} ') WHERE id = {$_GET['botid']}";
					db_query($qry);
					if(count($fileArr) > 0){
						$context['hidden'] = $fileArr;
						$context['nextstep'] = 2;
					}else{
						$context['nextstep'] = 3;
					}
				}else{
					$context['sub_template'] = 'sysmsg';
					$context['bot_msg'] = $txt['bot_teaching_complete'];
					$qry = "UPDATE {$db_prefix}bots SET botloaded = 1 WHERE  id = {$_GET['botid']}";
                    db_query($qry,__FILE__,__LINE__);
				}
		 	}
		}
		loadTemplate('botAdmin');
	}

	function EnableBot(){
		global $context, $db_prefix, $txt;
		$context['page_title'] = 'Enable Bot';
		if(!isset($_GET['botid'])){
			$context['sub_template']= 'sysmsg';			
			$context['bot_msg'] = $txt['bot_no_id'];
		}else{
			$qry = "SELECT ID_MEMBER, enabled, botloaded, boards FROM {$db_prefix}bots WHERE id = {$_GET['botid']}";
			$qid = db_query($qry,__FILE__,__LINE__);
			list($userid, $enable, $loaded, $board) = mysql_fetch_array($qid,MYSQL_BOTH);
			mysql_free_result($qid);
			if($enable == 0){
				if($loaded == 0 || $userid == 0 || $board == 0){
					// this bot cannot be enabled
					$context['sub_template'] = 'sysmsg';
					$context['bot_msg'] = $txt['bot_cannot_enable'];
					if($loaded == 0){
						$context['bot_msg'] .= '<br />' . $txt['bot_not_loaded'];
					}
					if($userid == 0){
						$context['bot_msg'] .= '<br />' . $txt['bot_not_member'];
					}
					if($board == 0){
						$context['bot_msg'] .= '<br />' . $txt['bot_no_board'];
					}
				}else{
					$qry = "UPDATE {$db_prefix}bots SET enabled = 1 WHERE id = {$_GET['botid']}";
					db_query($qry,__FILE__,__LINE__);	
					$context['sub_template'] = 'sysmsg';
					$context['bot_msg'] = $txt['bot_enabled_complete'];
				}	
			}else{
				$context['sub_template'] = 'sysmsg';
				$context['bot_msg'] = $txt['bot_disabled_complete'];
				$qry = "UPDATE {$db_prefix}bots SET enabled = 0 WHERE id = {$_GET['botid']}";
				db_query($qry,__FILE__,__LINE__);
			}
		}
		
		loadTemplate('botAdmin');
			
	}
	
	function EmptyMind(){
		global $context, $db_prefix, $txt;
		$context['page_title'] = 'Erase Mind';
		if(!isset($_GET['botid'])){
			$context['sub_template'] = 'sysmsg';
			$context['bot_msg'] = $txt['bot_no_id'];	
		}
		if(!is_numeric($_GET['botid'])){
			$context['sub_template'] = 'sysmsg';
			$context['bot_msg'] = $txt['bot_no_id'];
			// check if there is a way to log an error here so that people can tell that a hack attempt happened.	
		}
		$context['botid'] = $_GET['botid'];
		if(!isset($_GET['do']) || $_GET['do'] == 0){
			$qry = "DELETE FROM {$db_prefix}patterns WHERE bot = {$_GET['botid']}";
			db_query($qry);
			$context['do'] = 1;
			$context['sub_template'] = 'botEraseStep';
			$context['bot_msg'] = $txt['bot_remove_patterns'];
		}elseif($_GET['do'] == 1){
			$qry = "DELETE FROM {$db_prefix}templates WHERE bot = {$_GET['botid']}";
			db_query($qry);
			$context['do'] = 2;
			$context['sub_template'] = 'botEraseStep';
			$context['bot_msg'] = $txt['bot_remove_templates'];
		}elseif($_GET['do'] == 2){
			$qry = "UPDATE {$db_prefix}bots SET enabled = 0, botloaded = 0, files = '' WHERE id = {$_GET['botid']}";
			db_query($qry);
			$context['do'] = 3;
			$context['sub_template'] = 'botEraseStep';
			$context['bot_msg'] = $txt['bot_reset'];
		}else{
			$context['sub_template'] = 'sysmsg';
			$context['bot_msg'] = $txt['bot_mind_deleted'];
		}
		loadTemplate('botAdmin');
	}
?>