<?php
$qry['table_bot'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}bot (
  id int(11) NOT NULL auto_increment,
  bot tinyint(4) NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  value text NOT NULL,
  PRIMARY KEY  (id),
  KEY botname (bot,name)
) TYPE=MyISAM";
	
$qry['table_bots'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}bots (
  id tinyint(3) unsigned NOT NULL auto_increment,
  botname varchar(255) NOT NULL default '',
  ID_MEMBER bigint(10) unsigned NOT NULL default 0,
  enabled tinyint(3) unsigned NOT NULL default 1,
  botloaded tinyint(3) unsigned NOT NULL default 0,
  boards bigint(10) NOT NULL default 0,
  files longtext NOT NULL,
  PRIMARY KEY  (botname),
  KEY id (id)
) TYPE=MyISAM";


$qry['table_convlog'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}conversationlog (
  bot tinyint(3) unsigned NOT NULL default '0',
  id int(11) NOT NULL auto_increment,
  input text,
  response text,
  uid varchar(255) default NULL,
  enteredtime timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY botid (bot)
) TYPE=MyISAM";

$qry['table_dstore'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}dstore (
  uid varchar(255) default NULL,
  name text,
  value text,
  enteredtime timestamp(14) NOT NULL,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id),
  KEY nameidx (name(40))
) TYPE=MyISAM";


$qry['table_gmcache'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}gmcache (
  id int(11) NOT NULL auto_increment,
  bot tinyint(3) unsigned NOT NULL default '0',
  template int(11) NOT NULL default '0',
  inputstarvals text,
  thatstarvals text,
  topicstarvals text,
  patternmatched text,
  inputmatched text,
  combined text NOT NULL,
  PRIMARY KEY  (id),
  KEY combined (bot,combined(255))
) TYPE=MyISAM";


$qry['table_gossip'] = " CREATE TABLE IF NOT EXISTS {$db_prefix}gossip (
  bot tinyint(3) unsigned NOT NULL default '0',
  gossip text,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id),
  KEY botidx (bot)
) TYPE=MyISAM";

$qry['table_patterns'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}patterns (
  bot tinyint(3) unsigned NOT NULL default '0',
  id int(11) NOT NULL auto_increment,
  word varchar(255) default NULL,
  ordera tinyint(4) NOT NULL default '0',
  parent int(11) NOT NULL default '0',
  isend tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY wordparent (parent,word),
  KEY botid (bot)
) TYPE=MyISAM";



$qry['table_templates'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}templates (
  bot tinyint(3) unsigned NOT NULL default '0',
  id int(11) NOT NULL default '0',
  template text NOT NULL,
  pattern varchar(255) default NULL,
  that varchar(255) default NULL,
  topic varchar(255) default NULL,
  PRIMARY KEY  (id),
  KEY botid (bot)
) TYPE=MyISAM";


$qry['table_index'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}thatindex (
  uid varchar(255) default NULL,
  enteredtime timestamp(14) NOT NULL,
  id int(11) NOT NULL auto_increment,
  PRIMARY KEY  (id)
) TYPE=MyISAM";


$qry['table_stack'] = "CREATE TABLE IF NOT EXISTS {$db_prefix}thatstack (
  thatid int(11) NOT NULL default '0',
  id int(11) NOT NULL auto_increment,
  value varchar(255) default NULL,
  enteredtime timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM";


foreach($qry as $id=>$query){
	db_query($query, __FILE__, __LINE__);
}

function loadSettings($setting, $value){
	global $db_prefix;
	$qry = "INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('{$setting}', '{$value}')";
	db_query($qry, __FILE__, __LINE__);	
}


// these settings are only defaults when you create a bot for the first time. You can edit the 
// settings for each bot.

loadSettings('botDEFgender', 'female');
loadSettings('botDEFmaster', 'Administrator');
loadSettings('botDEFbirthday', '01 April 2007');
loadSettings('botDEFbirthplace', 'Germany');
loadSettings('botDEFboyfriend', 'I have no boyfriend');
loadSettings('botDEFgirlfriend', 'A.L.I.C.E');
loadSettings('botDEFfavoritebook', 'Do Androids Dream of Electric Sheep?');
loadSettings('botDEFfavoritecolor', '#5FA015');
loadSettings('botDEFfavoriteband', 'rubber');
loadSettings('botDEFfavoritefood', 'a simple Byte');
loadSettings('botDEFfavoritesong', 'Your voice');
loadSettings('botDEFfavoritemovie', 'I, Robot');
loadSettings('botDEFfavoriteauthor','Philip K. Dick');
loadSettings('botDEFfavoriteactor', 'Sonny');
loadSettings('botDEFhockeyteam', 'I do not care for hockey');
loadSettings('botDEFfootballteam', 'I do not care for football');
loadSettings('botDEFcelebrity','Daniel Day Louis');
loadSettings('botDEFcelebrities', 'There sure are a lot of them');
loadSettings('botDEFreligion', 'Userist');
loadSettings('botDEFarch','Place the server here');
loadSettings('botDEFos','Place the OS here');
loadSettings('botDEFparty','without a party');
loadSettings('botDEFfavoritesport', 'I do not care for sports');
loadSettings('botDEFbuild', '0.9');
loadSettings('botDEFbaseballteam','I do not care for baseball');
loadSettings('botDEFfavoriteartist','Who has time to look at art');
loadSettings('botDEFfavoriteactress', 'Halle Berry');
loadSettings('botDEFdevelopers', 'A lot of');
loadSettings('botDEFndevelopers', 'A lot of');
loadSettings('botDEFpresident','You should know that already');
loadSettings('botDEFforfun', 'Chatting');
loadSettings('botDEFfriends', 'Lots of different people');
loadSettings('botDEFkindmusic', 'Electropop');
loadSettings('botDEFlocation', 'here');
loadSettings('botDEFlooklike', 'everyone');
loadSettings('botDEFquestion', 'What?');
loadSettings('botDEFsign', 'Yield');
loadSettings('botDEFtalkabout', 'Everything');
loadSettings('botDEFwear', 'nothing');
loadSettings('botDEFlanguate', 'Any');
loadSettings('botDEFnationality', 'International');

//loadSettings('botCrossTalk', '0');
loadSettings('botAutoUserCreate', '1');
loadSettings('botVersion', '0.1a1');
loadSettings('botEmail', '@yourcom.com');
loadSettings('botPasswordLength', '10');
?>